unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, system.Diagnostics,
  Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    BitBtn1: TBitBtn;
    Edit1: TEdit;
    BitBtn2: TBitBtn;
    LabeledEdit1: TLabeledEdit;
    BitBtn3: TBitBtn;
    CheckBox1: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private 錾 }
    function Ninput(var n: integer): boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{
  xk[CvZASY
  B0,B1  ʕ\
  B2ȍ~Seidel's algorithm gp̌vZ菇łB
  xk[CvZAłʂ̂ȂvZ菇łB
@Seidel's algorithm for Tn Bnp  B2`
        0 1 2 3 4  5  6  7(8)       Tn-1   n= 2,4,6,(8) Ō̕\.[vI
   Tn = 1,1,1,2,5,16,61,272
     [0] [1] [2] [3] [4] [5] [6]              () for[v
      1                               [0]=1          l
 2    1   1                      ->   ([1]=[0]+[1]) upvZ lt[0]\
      2   2   1                  <-   [2]=[1] ([1]=[2]+[0]) [0]=[1]  downvZ
 4    2   4   5   5              ->   ([1]=[0]+[1] ` [3]=[2]+[3])
     16  16  14  10  5           <-   [4]=[3] ([3]=[4]+[2] ` [1]=[2]+[0]) [0]=[1]
 6   16  32  46  56  61  61   @ ->   ([1]=[0]+[1] ` [5]=[4]+[5])
    272 272 256 224 178 122  61  <-   [6]=[5] ([5]=[6]+[4] ` [1]=[2]+[0]) [0]=[1]
 8 TnvZ[vIt[0]\
 }

uses Velthuis.BigIntegers;

const
  Ni = 3000;                              // őxk[CNo  Biginteger


// ő  [Nbȟݏ@ int64
function gcd_int64(x, y: int64): int64;
var
  t : int64;
begin
  while y <> 0 do begin
    t := x mod y;
    x := y;
    y := t;
  end;
  result := x;
end;

//------------------------------------------------------------------------------

// xk[CvZ integer n=14
// QlvO
// ̃ASY\Ƃ͈Ⴂ܂AIC[vZƓ菇ɂȂĂ܂B
// B0,B1͒PƌvZ
// B2ȍ~Seidel's algorithmɂvZ
// zt[0]xk[CpTn B2`̒lƂȂt[i]IC[E2`ƂȂA
// IC[p̔z񗘗pt[i]xk[CpTn B2`̒lƂȂt[0]IC[E2`ƂȂ܂B
// ő̃xk[CNovZdownvZʂȌvZƂȂ̂ifŔĂ܂B
// Seidel's algorithm for Tn B2`   Euler_numbersƂ̌vZr
procedure TForm1.BitBtn3Click(Sender: TObject);
const
  k = 14;                                 // k = 14傫l1ntegwr I[o[t[
var
  t : array of integer;
  i, j, m, n : integer;
  b1, b2, q, g : integer;
  B : integer;
  kv2m1 : integer;
  bstr : string;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;

  // l\
  procedure memoout;
  begin
    if b1 < 0 then bstr := ' = '
              else bstr := ' =  ';
    memo1.Lines.Append('B' + intTostr(n) + bstr + inttostr(b1) +' / ' + intTostr(b2));
  end;

begin
  StopWatch := TStopwatch.StartNew;

  if checkbox1.checked = False then                       // xk[Cp
    setlength(t, k)                                         // zmہ@lNA
  else                                                    // IC[Ɠ
    setlength(t, k + 1);                                    // zmہ@lNA

  b := 0;                                                 // b {sv
  memo1.Clear;

  n := 0; b1 :=  1; b2 := 1; memoout;                     // B0
  n := 1; b1 := -1; b2 := 2; memoout;                     // B1

  // Seidel's algorithm for Tn (IC[Ɠ[v̏ꍇ Tnl̎oႢ܂)
  if checkbox1.checked = False then
    t[1] := 1                                             // ql xk[Cp[v
  else
    t[0] := 1;                                            // ql IC[Ɠ[v
  q := 1;                                                 // ꏉl
  kv2m1 := k div 2 - 1;                                   // B0,B1 -1
  for m := 0 to kv2m1 do begin                            // for i = 0 step 2  B2`
    i := m shl 1;                                         // i = m * 2
    // xk[Cp[v
    if checkbox1.checked = False then begin
      for j := i downto 1 do t[j] := t[j + 1] + t[j - 1];   // <- ŏi=0͎s
      t[0] := t[1];                                         // Tn=t[0] xk[CTn
      if m < kv2m1 then begin                               // Ō͎sȂ
        for j := 1 to i do t[j] := t[j] + t[j - 1] ;        // -> ŏi=0͎s
        t[i + 1] := t[i];                                   // t[i] IC[
      end;
    end
    // IC[Ɠ[v
    else begin
      for j := 1 to i do t[j] := t[j] + t[j - 1];           // ->
      b := t[i];                                            // Tn = t[i] xk[CTn
      if m < kv2m1 then begin                               // Ō͎sȂ IC[ł͎s
        t[i + 1] := t[i];
        for j := i downto 1 do t[j] := t[j + 1] + t[j - 1]; // <-
        t[0] := t[1];                                       // t[0] IC[ƂȂ܂
      end;
    end;
    n := i + 2;                                           // xk[CNo i + 2

    // q̌vZ
    if checkbox1.checked = False then                     // xk[Cp[vp
      b1 := n * t[0]                                        // q  n * t[0] t[0]=Tn
    else                                                  // IC[Ɠ[v̏ꍇ @
      b1 := n * b;                                          // q  n * b  b=Tn
    // ̌vZ
    q := q shl 2;                                         //   2^n  q = q * 4
    b2 := q * (q - 1);                                    //  V   4^n  - 2^n
    // ő񐔂ŕqŏl
    g := gcd_int64(b1, b2);                               // ő
    b1 := b1 div g;
    b2 := b2 div g;
    if n mod 4 = 0 then b1 := - b1;                       // ݒ

    memoout;                                              // l\
  end;

  StopWatch.Stop;
  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;
  Edit1.text := ' = ' + intTostr(ElapsedMillseconds) + 'msec';
end;

//------------------------------------------------------------------------------

// ԏ̃ASYɂvO
// xk[CvZ int64 n=22
// B0,1PƂŌvZABn n=2`k-1 upO, n=k ͍ŏIdown[v
// Seidel's algorithm for Tn B2`
procedure TForm1.BitBtn1Click(Sender: TObject);
const
  k = 22;                             // k = 22傫l1nt64 I[o[t[
var
  t : array of int64;
  j, n : integer;
  b1, b2, q, g : int64;
  bstr : string;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;

  // xk[Cl\
  procedure memoout;
  begin
    if b1 < 0 then bstr := ' = '
              else bstr := ' =  ';
    memo1.Lines.Append('B' + intTostr(n) + bstr + inttostr(b1) +' / ' + intTostr(b2));
  end;

  // Tn̒lBnlɕϊ\
  procedure TntoBn;
  begin
    b1 := n * t[0];                                       // q  n * Tn
    q := q shl 2;                                         //   2^n  q = q * 4
    b2 := q * (q - 1);                                    //  V   4^n  - 2^n
    g := gcd_int64(b1, b2);                               // ő
    b1 := b1 div g;
    b2 := b2 div g;
    if n mod 4 = 0 then b1 := - b1;                       // ݒ
    memoout;                                              // l\
  end;

begin
  StopWatch := TStopwatch.StartNew;

  memo1.Clear;

  n := 0; b1 :=  1; b2 := 1; memoout;                     // B0
  n := 1; b1 := -1; b2 := 2; memoout;                     // B1

  // Seidel's algorithm for Tn  Bnlt[0]Ƃxk[CvZ[v B2`
  setlength(t, k - 1);                                    // zmہ@lNA
  t[0] := 1;                                              // qWl
  q := 1;                                                 // Wl
  n := 2;                                                 // forto n=2 l
  repeat
    TntoBn;                                               // xk[C\Tn = t[0]
    for j := 0 to n - 2 do t[j + 1] := t[j] + t[j + 1];        // ->
    t[n] := t[n - 1];
    for j := n - 2  downto 0 do t[j + 1] := t[j] + t[j + 2];   // <-
    t[0] := t[1];
    inc(n, 2);                                            // forto n=n+2 step2
  until n >= k;
  TntoBn;                                                 // xk[C\Tn = t[0]

  StopWatch.Stop;
  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;
  Edit1.text := ' = ' + intTostr(ElapsedMillseconds) + 'msec';
end;

//================================ Biginteger ==================================

// xk[CNo͏
function TForm1.Ninput(var n: integer): boolean;
var
  c : integer;
begin
  result := true;
  val(labelededit1.Text, n, c);
  if c <> 0 then begin
    memo1.Text := 'xk[CNo ɊԈႢ܂B';
    result := false;
    exit;
  end;
  if n < 0 then begin
    memo1.Text := 'xk[CNo̓[ȏɂĉB';
    result := false;
  end;
  if n > NI then begin
    memo1.Text := 'xk[CNo 傫܂' + intTostr(NI) + 'łB';
    result := false;
  end;
end;

// ő  [Nbȟݏ@ biginteger
function gcd_big(x, y: biginteger): biginteger;
var
  t : biginteger;
begin
  while y <> 0 do begin
    t := x mod y;
    x := y;
    y := t;
  end;
  result := x;
end;

// xk[CvZ biginteger
// B0,1PƂŌvZABn n=2`k-1 upO, n=k down[v
procedure TForm1.BitBtn2Click(Sender: TObject);
const
  MM = 36;                                  // xk[Cꗗ\͈
var
  t : array of biginteger;
  j, n, k : integer;
  b1, b2, q, g : biginteger;
  bstr : string;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;

  // xk[Cl\
  procedure memoout;
  begin
    if b1 < 0 then bstr := ' = '
              else bstr := ' =  ';
    memo1.Lines.Append('B' + intTostr(n) + bstr + b1.ToString +' / ' + b2.ToString);
  end;

  // Tn̒lBnlɕϊ\
  procedure TntoBn;
  begin
    q := q shl 2;                                         //   2^n  q = q * 4
    if (k <= MM) or ((n > MM) and (n = k)) then begin
      b1 := n * t[0];                                     // q  n * Tn
      b2 := q * (q - 1);                                  //   4^n  - 2^n
      g := gcd_big(b1, b2);                               // ő
      b1 := b1 div g;
      b2 := b2 div g;
      if n mod 4 = 0 then b1 := - b1;                     // ݒ
      memoout;
    end;                                                  // l\
  end;

begin
  if not Ninput(k) then exit;                               // vZxk[CNo
  StopWatch := TStopwatch.StartNew;

  memo1.Clear;

  if k <= MM then begin
    n := 0; b1 :=  1; b2 := 1; memoout;                     // B0
    if k < 1 then exit;
    n := 1; b1 := -1; b2 := 2; memoout;                     // B1
    if k < 2 then exit;
  end;

  // vZ͈͎w@Nô݌vZ B2`
  if (k <= MM) or ((k > MM) and (k mod 2 = 0)) then begin
    // Seidel's algorithm for Tn
    setlength(t, k - 1);                                    // zmہ@lNA
    t[0] := 1;                                              // qWl
    q := 1;                                                 // Wl
    n := 2;                                                 // forto n=2 lB2
    repeat
      TntoBn;                                               // xk[C\Tn = t[0]
      for j := 0 to n - 2 do t[j + 1] := t[j] + t[j + 1];       // ->
      t[n] := t[n - 1];
      for j := n - 2 downto 0 do t[j + 1] := t[j] + t[j + 2];   // <-
      t[0] := t[1];
      inc(n, 2)                                             // forto n=n+2 step2
    until n >= k;
    TntoBn;                                                 // xk[C\Tn = t[0]
  end;
  // No\  "0/1" \
  if (k mod 2 <> 0) then begin                              // no@0/1\
    n := k; b1 := 0; b2 := 1;
    memoout;                                                // xk[C\ 0/1
  end;
  StopWatch.Stop;
  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;
  Edit1.text := ' = ' + intTostr(ElapsedMillseconds) + 'msec';
end;

//------------------------------------------------------------------------------

procedure TForm1.FormCreate(Sender: TObject);
begin
  labeledEdit1.EditLabel.Caption := 'Bn n<=' + intTostr(NI);
end;

end.

